<?php


function ListDirectory($baseDir, $dir, &$dirList, &$fileList)
{
  $res = @opendir($baseDir.$dir);
  if (!$res)
    return false;
  while (false !== ($file = readdir($res))) {
    $ffile = $dir."/".$file;
    if (is_dir($baseDir.$ffile)) {
      if ($file != ".." && $file != ".") {
	$dirList[] = $ffile;
	ListDirectory($baseDir, $ffile, $dirList, $fileList);
      }
    }
    else {
      $fileList[] = $ffile;
    }
  }
  closedir($res);
  return true;
}


class SendNewsLetter extends Module
{
  public function __construct()
  {
    $this->name = 'sendnewsletter';
    $this->tab = 'Admin';
    $this->tabClassName = 'AdminNewsletter';
    $this->tabParentName = 'AdminCustomers';
    $this->version = '1.0';
    $this->srcDir = _PS_MODULE_DIR_.$this->name.'/';
    $this->dstDir = _PS_ROOT_DIR_.'/';

    parent::__construct();

    /* The parent construct is required for translations */
    $this->page = basename(__FILE__, '.php');
    $this->description = $this->l('Этот модуль позволяет делать рассылку e-mail писем с новостями.');
    $this->displayName = $this->l('Отправка писем');
    $dirList = array();
    $fileList = array();
    $res = ListDirectory($this->srcDir, 'js', $dirList, $fileList);
    foreach ($fileList as $file)
      $res = $res && file_exists($this->dstDir.$file);
    if (!$res) {
      $this->warning = $this->l('Файлы не скопировнны из').
	' '.$this->srcDir.'js '.$this->l('to').' '.$this->dstDir.'js. '.
	$this->l('Вам необходимо скопировать файлы в ручную.');
    }
  }

  public function install()
  {
    $id_tab = Tab::getIdFromClassName($this->tabClassName);
    if (!$id_tab) {
      $tab = new Tab();
      $tab->class_name = $this->tabClassName;
      $tab->id_parent = Tab::getIdFromClassName($this->tabParentName);
      $tab->module = $this->name;
      $languages = Language::getLanguages();
      foreach ($languages as $language)
	$tab->name[$language['id_lang']] = $this->displayName;
      $tab->add();
    }
    $srcLogoName = _PS_MODULE_DIR_.$this->name.'/logo.gif';
    $dstLogoName = _PS_IMG_DIR_.'t/AdminNewsletter.gif';
    copy($srcLogoName, $dstLogoName);
    $dirList = array();
    $fileList = array();
    $res = ListDirectory($this->srcDir, 'js', $dirList, $fileList);
    if ($res) {
      foreach ($dirList as $dir)
	@mkdir($this->dstDir.$dir);
      foreach ($fileList as $file)
	@copy($this->srcDir.$file, $this->dstDir.$file);
    }
    return parent::install();
  }

  public function uninstall()
  {
    $id_tab = Tab::getIdFromClassName($this->tabClassName);
    if ($id_tab) {
      $tab = new Tab($id_tab);
      $tab->delete();
    }
    $dirList = array();
    $fileList = array();
    $res = ListDirectory($this->srcDir, 'js', $dirList, $fileList);
    if ($res) {
      foreach ($fileList as $file)
	@unlink($this->dstDir.$file);
      foreach ($dirList as $dir)
	@rmdir($this->dstDir.$dir);
    }
    return parent::uninstall();
  }
}

?>
